# Thirdweb Contracts v2

> [Looking for version 1? Click here!](https://github.com/thirdweb-dev/contracts/tree/v1)

Lets anyone deploy their own copy of the smart contracts on the platform.

### Deployments

- `TWRegistry`: [0x7c487845f98938Bb955B1D5AD069d9a30e4131fd](https://blockscan.com/address/0x7c487845f98938Bb955B1D5AD069d9a30e4131fd)

- `TWFactory`: [0x11c34F062Cb10a20B9F463E12Ff9dA62D76FDf65](https://blockscan.com/address/0x11c34F062Cb10a20B9F463E12Ff9dA62D76FDf65)

### ByocRegistry - Polygon
- `TWRegistry`: [0xF6abb5014Fb6F1Aa615b960fc28bB9C180b6cc44](https://blockscan.com/address/0xF6abb5014Fb6F1Aa615b960fc28bB9C180b6cc44#code)

- `ByocRegistry`: [0x1B0284a1C9b3fC50067641702a6ed11a76B01256](https://polygonscan.com/address/0x1B0284a1C9b3fC50067641702a6ed11a76B01256#code)

### ByocRegistry - Mumbai

- `TWRegistry`: [0x3F17972CB27506eb4a6a3D59659e0B57a43fd16C](https://blockscan.com/address/0x3F17972CB27506eb4a6a3D59659e0B57a43fd16C#code)

- `ByocRegistry` (Mumbai): [0xa9CBE73a575038103c3Baaaf7Db51374a60a5209](https://mumbai.polygonscan.com/address/0xa9CBE73a575038103c3Baaaf7Db51374a60a5209#code)

## Running Tests
1. `yarn`: install contracts dependencies
2. `forge install`: install tests dependencies
3. `forge test`: run the tests

## Feedback

If you have any feedback, please reach out to us at support@thirdweb.com.



## Authors

- [thirdweb](https://thirdweb.com)

## License

[Apache 2.0](https://www.apache.org/licenses/LICENSE-2.0.txt)
