import { utils, BytesLike, BaseContract, Signer, CallOverrides, BigNumber, PopulatedTransaction } from 'ethers';
import { FunctionFragment, Result } from '@ethersproject/abi';
import { Provider, Listener } from '@ethersproject/providers';
import { TypedEvent, TypedEventFilter, TypedListener, OnEvent } from './common';

interface CurrencyTransferLibInterface extends utils.Interface {
    contractName: string | "CurrencyTransferLib";
    functions: {
        "NATIVE_TOKEN()": FunctionFragment;
    };
    encodeFunctionData(functionFragment: "NATIVE_TOKEN", values?: undefined): string;
    decodeFunctionResult(functionFragment: "NATIVE_TOKEN", data: BytesLike): Result;
    events: {};
}
interface CurrencyTransferLib extends BaseContract {
    contractName: string | "CurrencyTransferLib";
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: CurrencyTransferLibInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        NATIVE_TOKEN(overrides?: CallOverrides): Promise<[string]>;
    };
    NATIVE_TOKEN(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        NATIVE_TOKEN(overrides?: CallOverrides): Promise<string>;
    };
    filters: {};
    estimateGas: {
        NATIVE_TOKEN(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        NATIVE_TOKEN(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}

export { CurrencyTransferLib, CurrencyTransferLibInterface };
