import { Signer } from 'ethers';
import { Provider } from '@ethersproject/providers';
import { IThirdwebContractInterface, IThirdwebContract } from '../IThirdwebContract';
import '@ethersproject/abi';
import '../common';

declare class IThirdwebContract__factory {
    static readonly abi: ({
        inputs: never[];
        name: string;
        outputs: {
            internalType: string;
            name: string;
            type: string;
        }[];
        stateMutability: string;
        type: string;
    } | {
        inputs: {
            internalType: string;
            name: string;
            type: string;
        }[];
        name: string;
        outputs: never[];
        stateMutability: string;
        type: string;
    })[];
    static createInterface(): IThirdwebContractInterface;
    static connect(address: string, signerOrProvider: Signer | Provider): IThirdwebContract;
}

export { IThirdwebContract__factory };
